## sdformat11 11.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

if(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
  CMAKE_POLICY(SET CMP0004 NEW)
endif(COMMAND CMAKE_POLICY)
enable_testing()

# with -fPIC
if(UNIX AND NOT WIN32)
  set (CMAKE_INSTALL_PREFIX "/usr" CACHE STRING "Install Prefix")
 find_program(CMAKE_UNAME uname /bin /usr/bin /usr/local/bin )
 if(CMAKE_UNAME)
   exec_program(uname ARGS -m OUTPUT_VARIABLE CMAKE_SYSTEM_PROCESSOR)
   set(CMAKE_SYSTEM_PROCESSOR ${CMAKE_SYSTEM_PROCESSOR} CACHE INTERNAL
     "processor type (i386 and x86_64)")
   if(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
     ADD_DEFINITIONS(-fPIC)
   endif(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
 endif(CMAKE_UNAME)
endif()

project (sdformat11)

# The protocol version has nothing to do with the package version set below.
# It represents the current version of sdformat implement by the software
set (SDF_PROTOCOL_VERSION 1.8)

set (SDF_MAJOR_VERSION 11)
set (SDF_MINOR_VERSION 3)
set (SDF_PATCH_VERSION 0)

set (SDF_VERSION ${SDF_MAJOR_VERSION}.${SDF_MINOR_VERSION})
set (SDF_VERSION_FULL ${SDF_MAJOR_VERSION}.${SDF_MINOR_VERSION}.${SDF_PATCH_VERSION})

string (TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
string(REGEX REPLACE "[0-9]+" "" PROJECT_NAME_NO_VERSION ${PROJECT_NAME})
string(TOLOWER ${PROJECT_NAME_NO_VERSION} PROJECT_NAME_NO_VERSION_LOWER)
set(PROJECT_EXPORT_NAME ${PROJECT_NAME_LOWER})
set(PROJECT_LIBRARY_TARGET_NAME ${PROJECT_NAME_LOWER})

set (project_cmake_dir ${PROJECT_SOURCE_DIR}/cmake
  CACHE PATH "Location of CMake scripts")

message (STATUS "${PROJECT_NAME} version ${SDF_VERSION_FULL}")
set (CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

#============================================================================
# We turn off extensions because (1) we do not ever want to use non-standard
# compiler extensions, and (2) this variable is on by default, causing cmake
# to choose the flag -std=gnu++14 instead of -std=c++14 when the C++14
# features are requested. Explicitly turning this flag off will force cmake to
# choose -std=c++14.
# See https://github.com/ignitionrobotics/ign-cmake/issues/13 for more info.
set(CMAKE_CXX_EXTENSIONS off)

# Include GNUInstallDirs to get canonical paths
include(GNUInstallDirs)

# Default test type for test all over source
set(TEST_TYPE "UNIT")

# developer's option to cache PKG_CONFIG_PATH and
# LD_LIBRARY_PATH for local installs
if(PKG_CONFIG_PATH)
  set (ENV{PKG_CONFIG_PATH} ${PKG_CONFIG_PATH}:$ENV{PKG_CONFIG_PATH})
endif()
if(LD_LIBRARY_PATH)
  set (ENV{LD_LIBRARY_PATH} ${LD_LIBRARY_PATH}:$ENV{LD_LIBRARY_PATH})
endif()

set (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/sdformat-${SDF_VERSION}/sdf")
set (LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR} CACHE STRING "Installation directory for libraries (relative to CMAKE_INSTALL_PREFIX)")
set (BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR} CACHE STRING "Installation directory for binaries (relative to CMAKE_INSTALL_PREFIX)")
set (USE_FULL_RPATH OFF CACHE BOOL "Set to true to enable full rpath")

set(PKG_NAME SDFormat)
set(sdf_target sdformat${SDF_MAJOR_VERSION})
set(sdf_config_install_dir "${LIB_INSTALL_DIR}/cmake/${PROJECT_NAME_LOWER}/")
set(sdf_import_target_name ${PROJECT_EXPORT_NAME}::${sdf_target})
set(sdf_target_output_filename "${sdf_target}-targets.cmake")


OPTION(SDFORMAT_DISABLE_CONSOLE_LOGFILE "Disable the sdformat console logfile" OFF)

if (USE_FULL_RPATH)
  # use, i.e. don't skip the full RPATH for the build tree
  set(CMAKE_SKIP_BUILD_RPATH  FALSE)

  # when building, don't use the install RPATH already
  # (but later on when installing)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")

  # add the automatically determined parts of the RPATH
  # which point to directories outside the build tree to the install RPATH
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

  # the RPATH to be used when installing, but only if its not a system directory
  list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}" isSystemDir)
  if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
  endif("${isSystemDir}" STREQUAL "-1")
endif()

set (BUILD_SDF ON CACHE INTERNAL "Build SDF" FORCE)
set (build_errors "" CACHE INTERNAL "build errors" FORCE)
set (build_warnings "" CACHE INTERNAL "build warnings" FORCE)

set (sdf_cmake_dir ${PROJECT_SOURCE_DIR}/cmake CACHE PATH
     "Location of CMake scripts")

message (STATUS "\n\n====== Finding 3rd Party Packages ======")
include (${sdf_cmake_dir}/SDFUtils.cmake)
include (${sdf_cmake_dir}/SearchForStuff.cmake)
message (STATUS "----------------------------------------\n")

#####################################
# Set the default build type
if (NOT CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug Release RelWithDebInfo Profile Check" FORCE)
endif (NOT CMAKE_BUILD_TYPE)
string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_UPPERCASE)

set (BUILD_TYPE_PROFILE FALSE)
set (BUILD_TYPE_RELEASE FALSE)
set (BUILD_TYPE_RELWITHDEBINFO FALSE)
set (BUILD_TYPE_DEBUG FALSE)

if ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "PROFILE")
  set (BUILD_TYPE_PROFILE TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "RELEASE")
  set (BUILD_TYPE_RELEASE TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "RELWITHDEBINFO")
  set (BUILD_TYPE_RELWITHDEBINFO TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "DEBUG")
  set (BUILD_TYPE_DEBUG TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "COVERAGE")
  include (${project_cmake_dir}/CodeCoverage.cmake)
  set (BUILD_TYPE_DEBUG TRUE)
  SETUP_TARGET_FOR_COVERAGE(coverage ctest coverage)
else()
  # NONE is a valid CMAKE_BUILD_TYPE
  if (NOT "${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "NONE")
    build_error("CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} unknown. Valid options are: Debug Release RelWithDebInfo Profile Coverage None")
  endif()
endif()

#============================================================================
# Ask whether we should make a shared or static library.
option(BUILD_SHARED_LIBS "Set this to true to generate shared libraries (recommended), or false for static libraries" ON)

#####################################
# Handle CFlags
unset (CMAKE_C_FLAGS_ALL CACHE)

# USE_HOST_CFLAGS (default TRUE)
# Will check building host machine for proper cflags
if(NOT DEFINED USE_HOST_CFLAGS OR USE_HOST_CFLAGS)
  message(STATUS "Enable host CFlags")
  include (${project_cmake_dir}/HostCFlags.cmake)
endif()

# USE_UPSTREAM_CFLAGS (default TRUE)
# Will use predefined ignition developers cflags
if(NOT DEFINED USE_UPSTREAM_CFLAGS OR USE_UPSTREAM_CFLAGS)
  message(STATUS "Enable upstream CFlags")
  include(${project_cmake_dir}/DefaultCFlags.cmake)
endif()

# Check if warning options are avaliable for the compiler and return WARNING_CXX_FLAGS variable
if (MSVC)
  set(WARN_LEVEL "/W4")

  # Unable to be filtered flags (failing due to limitations in filter_valid_compiler_warnings)
  # Handling exceptions rightly and ignore unknown pragmas
  set(UNFILTERED_FLAGS "/EHsc /wd4068")
else()
  # Equivalent to Wall (according to man gcc) but removed the unknown pragmas since we use
  # MSVC only pragmas all over the code
  list(APPEND WARN_LEVEL -Waddress -Warray-bounds -Wcomment -Wformat -Wnonnull)
  list(APPEND WARN_LEVEL -Wparentheses -Wreorder -Wreturn-type)
  list(APPEND WARN_LEVEL -Wsequence-point -Wsign-compare -Wstrict-aliasing)
  list(APPEND WARN_LEVEL -Wstrict-overflow=1 -Wswitch -Wtrigraphs -Wuninitialized)
  list(APPEND WARN_LEVEL -Wunused-function -Wunused-label -Wunused-value)
  list(APPEND WARN_LEVEL -Wunused-variable -Wvolatile-register-var)

  # Unable to be filtered flags (failing due to limitations in filter_valid_compiler_warnings)
  set(UNFILTERED_FLAGS "-Wc++17-compat")
endif()

filter_valid_compiler_warnings(${WARN_LEVEL} -Wextra -Wno-long-long
  -Wno-unused-value -Wno-unused-value -Wno-unused-value -Wno-unused-value
  -Wfloat-equal -Wshadow -Winit-self -Wswitch-default
  -Wmissing-include-dirs -pedantic -Wno-pragmas)
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}${WARNING_CXX_FLAGS} ${UNFILTERED_FLAGS}")

#################################################
# OS Specific initialization
if (UNIX)
  sdf_setup_unix()
endif ()

if (WIN32)
  sdf_setup_windows()
endif ()

if (APPLE)
  sdf_setup_apple()
endif ()

#################################################
# Print warnings and errors
if ( build_warnings )
  message(WARNING "-- BUILD WARNINGS")
  foreach (msg ${build_warnings})
    message(WARNING "-- ${msg}")
  endforeach ()
  message(WARNING "-- END BUILD WARNINGS\n")
endif (build_warnings)

########### Add uninstall target ###############
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P
  "${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake")

if (build_errors)
  message(SEND_ERROR "-- BUILD ERRORS: These must be resolved before compiling.")
  foreach (msg ${build_errors})
    message(SEND_ERROR "-- ${msg}")
  endforeach ()
  message(SEND_ERROR "-- END BUILD ERRORS\n")
  message (FATAL_ERROR "Errors encountered in build. Please see the BUILD ERRORS above.")

else (build_errors)

  ########################################
  # Write the config.h file
  configure_file (${sdf_cmake_dir}/sdf_config.h.in
    ${PROJECT_BINARY_DIR}/sdf/sdf_config.h)
  sdf_install_includes("" ${PROJECT_BINARY_DIR}/sdf/sdf_config.h)

  message (STATUS "C Flags:${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE}}")
  message (STATUS "Build Type: ${CMAKE_BUILD_TYPE}")
  message (STATUS "Install path: ${CMAKE_INSTALL_PREFIX}")

  if (BUILD_SDF)
    include_directories(include
      ${PROJECT_BINARY_DIR}
      ${PROJECT_BINARY_DIR}/include
      )

    link_directories(${PROJECT_BINARY_DIR}/src)

    if (NOT DEFINED BUILD_TESTING OR BUILD_TESTING)
      set(BUILD_SDF_TEST TRUE)
    else()
      set(BUILD_SDF_TEST FALSE)
    endif()

    if (BUILD_SDF_TEST)
      add_subdirectory(test)
    endif()
    add_subdirectory(src)
    add_subdirectory(include/sdf)
    add_subdirectory(sdf)
    add_subdirectory(conf)
    add_subdirectory(doc)
  endif(BUILD_SDF)

  ########################################
  # Setup Codecheck
  include (IgnCodeCheck)
  set(CPPCHECK_DIRS
    ${PROJECT_SOURCE_DIR}/src
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/test/integration
    ${PROJECT_SOURCE_DIR}/test/performance)

  set(CPPCHECK_INCLUDE_DIRS
    ${PROJECT_BINARY_DIR}
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/test/integration
    ${PROJECT_SOURCE_DIR}/test/performance)

  # Ignore vendored directories.
  file(WRITE ${PROJECT_BINARY_DIR}/cppcheck.suppress
    "*:${PROJECT_SOURCE_DIR}/src/urdf/*\n"
    )
  ign_setup_target_for_codecheck()

  ########################################
  # Make the package config file
  set(PC_CONFIG_INSTALL_DIR ${LIB_INSTALL_DIR}/pkgconfig)
  file(RELATIVE_PATH
    PC_CONFIG_RELATIVE_PATH_TO_PREFIX
    "${CMAKE_INSTALL_PREFIX}/${PC_CONFIG_INSTALL_DIR}"
    "${CMAKE_INSTALL_PREFIX}"
  )
  configure_file(${CMAKE_SOURCE_DIR}/cmake/sdformat_pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME_LOWER}.pc @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME_LOWER}.pc DESTINATION
    ${PC_CONFIG_INSTALL_DIR} COMPONENT pkgconfig)

  ########################################
  # Configure documentation uploader
  configure_file("${CMAKE_SOURCE_DIR}/cmake/upload_doc.sh.in"
    ${CMAKE_BINARY_DIR}/upload_doc.sh @ONLY)

  ########################################
  # Make the cmake config files
  set(sdf_config_input  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/sdf_config.cmake.in")
  set(sdf_config_output "cmake/${sdf_target}-config.cmake")
  set(sdf_version_output "cmake/${sdf_target}-config-version.cmake")

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

find_package(sdformat11 REQUIRED)

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")

include_directories(${SDFormat_INCLUDE_DIRS})
link_directories(${SDFormat_LIBRARY_DIRS})

add_executable(simple simple.cc)
target_link_libraries(simple ${SDFormat_LIBRARIES})

add_executable(dom dom.cc)
target_link_libraries(dom ${SDFormat_LIBRARIES})

=== sdf/CMakeLists.txt ===
add_subdirectory(1.0)
add_subdirectory(1.2)
add_subdirectory(1.3)
add_subdirectory(1.4)
add_subdirectory(1.5)
add_subdirectory(1.6)
add_subdirectory(1.7)
add_subdirectory(1.8)

add_custom_target(schema)
add_dependencies(schema schema1_8)

# Generate the EmbeddedSdf.cc file, which contains all the supported SDF
# descriptions in a map of strings. The parser.cc file uses EmbeddedSdf.hh.
execute_process(
  COMMAND ${RUBY} ${CMAKE_SOURCE_DIR}/sdf/embedSdf.rb
  WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/sdf"
  OUTPUT_FILE "${PROJECT_BINARY_DIR}/src/EmbeddedSdf.cc"
)

# Generate aggregated SDF description files for use by the sdformat.org 
# website. If the description files change, the generated full*.sdf files need 
# to be removed before running this target.
if (IGNITION-TOOLS_BINARY_DIRS)

  # Update this list as new sdformat spec versions are added.
  set(sdf_desc_versions 1.4 1.5 1.6 1.7 1.8)

  set(description_targets)
  foreach(desc_ver ${sdf_desc_versions})
    string(REPLACE "." "-" desc_ver_dash ${desc_ver})
    list(APPEND description_targets ${CMAKE_CURRENT_BINARY_DIR}/full_${desc_ver_dash}.sdf)
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/full_${desc_ver_dash}.sdf
      COMMAND
        ${CMAKE_COMMAND} -E env IGN_CONFIG_PATH=${CMAKE_BINARY_DIR}/test/conf
        ${IGNITION-TOOLS_BINARY_DIRS}/ign
      ARGS sdf -d ${desc_ver} > ${CMAKE_CURRENT_BINARY_DIR}/full_${desc_ver_dash}.sdf
      COMMENT "Generating full description for spec ${desc_ver}"
      VERBATIM)
  endforeach()
  add_custom_target(sdf_descriptions DEPENDS ${description_targets} ${sdf_target})
endif()

=== src/CMakeLists.txt ===
include (${sdf_cmake_dir}/SDFUtils.cmake)

link_directories(
  ${PROJECT_BINARY_DIR}/test
)

if (NOT USE_INTERNAL_URDF)
  link_directories(${URDF_LIBRARY_DIRS})
endif()

set (sources
  Actor.cc
  AirPressure.cc
  Altimeter.cc
  Atmosphere.cc
  Box.cc
  Camera.cc
  Capsule.cc
  Collision.cc
  Console.cc
  Converter.cc
  Cylinder.cc
  Element.cc
  Ellipsoid.cc
  EmbeddedSdf.cc
  Error.cc
  Exception.cc
  Frame.cc
  FrameSemantics.cc
  Filesystem.cc
  ForceTorque.cc
  Geometry.cc
  Gui.cc
  Heightmap.cc
  ign.cc
  InterfaceFrame.cc
  InterfaceJoint.cc
  InterfaceLink.cc
  InterfaceModel.cc
  InterfaceModelPoseGraph.cc
  Imu.cc
  Joint.cc
  JointAxis.cc
  Lidar.cc
  Light.cc
  Link.cc
  Magnetometer.cc
  Material.cc
  Mesh.cc
  Model.cc
  NavSat.cc
  Noise.cc
  parser.cc
  parser_urdf.cc
  ParserConfig.cc
  Param.cc
  ParamPassing.cc
  ParticleEmitter.cc
  Pbr.cc
  Physics.cc
  Plane.cc
  Root.cc
  Scene.cc
  SDF.cc
  SDFExtension.cc
  SemanticPose.cc
  Sensor.cc
  Sky.cc
  Sphere.cc
  Surface.cc
  Types.cc
  Utils.cc
  Visual.cc
  World.cc
  XmlUtils.cc
)
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

if (USE_INTERNAL_URDF)
  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/urdf)
  set(sources ${sources}
  urdf/urdf_parser/model.cpp
  urdf/urdf_parser/link.cpp
  urdf/urdf_parser/joint.cpp
  urdf/urdf_parser/pose.cpp
  urdf/urdf_parser/twist.cpp
  urdf/urdf_parser/urdf_model_state.cpp
  urdf/urdf_parser/urdf_sensor.cpp
  urdf/urdf_parser/world.cpp)
else()
  include_directories(${URDF_INCLUDE_DIRS})
endif()

if (BUILD_SDF_TEST)
  set (gtest_sources
    Actor_TEST.cc
    AirPressure_TEST.cc
    Altimeter_TEST.cc
    Atmosphere_TEST.cc
    Box_TEST.cc
    Camera_TEST.cc
    Capsule_TEST.cc
    Collision_TEST.cc
    Console_TEST.cc
    Cylinder_TEST.cc
    Element_TEST.cc
    Ellipsoid_TEST.cc
    Error_TEST.cc
    Exception_TEST.cc
    Frame_TEST.cc
    Filesystem_TEST.cc
    ForceTorque_TEST.cc
    Geometry_TEST.cc
    Gui_TEST.cc
    Heightmap_TEST.cc
    Imu_TEST.cc
    Joint_TEST.cc
    JointAxis_TEST.cc
    Lidar_TEST.cc
    Light_TEST.cc
    Link_TEST.cc
    Magnetometer_TEST.cc
    Material_TEST.cc
    Mesh_TEST.cc
    Model_TEST.cc
    NavSat_TEST.cc
    Noise_TEST.cc
    Param_TEST.cc
    parser_TEST.cc
    ParserConfig_TEST.cc
    ParticleEmitter_TEST.cc
    Pbr_TEST.cc
    Physics_TEST.cc
    Plane_TEST.cc
    Root_TEST.cc
    Scene_TEST.cc
    SemanticPose_TEST.cc
    SDF_TEST.cc
    Sensor_TEST.cc
    Sky_TEST.cc
    Sphere_TEST.cc
    Surface_TEST.cc
    Types_TEST.cc
    Visual_TEST.cc
    World_TEST.cc
  )

  # Build this test file only if Ignition Tools is installed.
  if (IGNITION-TOOLS_BINARY_DIRS)
    set (gtest_sources ${gtest_sources}
      ign_TEST.cc
    )
  endif()

  include_directories(${PROJECT_SOURCE_DIR}/test)
  sdf_build_tests(${gtest_sources})

  if (TARGET UNIT_ign_TEST)
    # Link the libraries that we always need.
    target_link_libraries("UNIT_ign_TEST"
      PUBLIC
        ignition-cmake${IGN_CMAKE_VER}::utilities
    )
  endif()

  if (NOT WIN32)
    set(SDF_BUILD_TESTS_EXTRA_EXE_SRCS Utils.cc)
    sdf_build_tests(Utils_TEST.cc)
  endif()

  if (NOT WIN32)
    set(SDF_BUILD_TESTS_EXTRA_EXE_SRCS XmlUtils.cc)
    sdf_build_tests(XmlUtils_TEST.cc)
    target_link_libraries(UNIT_XmlUtils_TEST PRIVATE
      ${TinyXML2_LIBRARIES})
  endif()

  if (NOT WIN32)
    set(SDF_BUILD_TESTS_EXTRA_EXE_SRCS FrameSemantics.cc)
    sdf_build_tests(FrameSemantics_TEST.cc)
  endif()

  if (NOT WIN32)
    set(SDF_BUILD_TESTS_EXTRA_EXE_SRCS Converter.cc EmbeddedSdf.cc XmlUtils.cc)
    sdf_build_tests(Converter_TEST.cc)
    target_link_libraries(UNIT_Converter_TEST PRIVATE
      ${TinyXML2_LIBRARIES})
  endif()

  if (NOT WIN32)
    set(SDF_BUILD_TESTS_EXTRA_EXE_SRCS SDFExtension.cc parser_urdf.cc XmlUtils.cc)
    sdf_build_tests(parser_urdf_TEST.cc)
    if (NOT USE_INTERNAL_URDF)
      target_compile_options(UNIT_parser_urdf_TEST PRIVATE ${URDF_CFLAGS})
      if (${CMAKE_VERSION} VERSION_GREATER 3.13)
        target_link_options(UNIT_parser_urdf_TEST PRIVATE ${URDF_LDFLAGS})
      endif()
      target_link_libraries(UNIT_parser_urdf_TEST PRIVATE ${URDF_LIBRARIES})
    endif()
    target_link_libraries(UNIT_parser_urdf_TEST PRIVATE
      ${TinyXML2_LIBRARIES})
  endif()

  if (NOT WIN32)
    set(SDF_BUILD_TESTS_EXTRA_EXE_SRCS ParamPassing.cc XmlUtils.cc parser.cc
    parser_urdf.cc FrameSemantics.cc Converter.cc EmbeddedSdf.cc SDFExtension.cc Utils.cc)
    sdf_build_tests(ParamPassing_TEST.cc)
    if (NOT USE_INTERNAL_URDF)
      target_compile_options(UNIT_ParamPassing_TEST PRIVATE ${URDF_CFLAGS})
      if (${CMAKE_VERSION} VERSION_GREATER 3.13)
        target_link_options(UNIT_ParamPassing_TEST PRIVATE ${URDF_LDFLAGS})
      endif()
      target_link_libraries(UNIT_ParamPassing_TEST PRIVATE ${URDF_LIBRARIES})
    endif()
    target_link_libraries(UNIT_ParamPassing_TEST PRIVATE
      ${TinyXML2_LIBRARIES})
  endif()
endif()

sdf_add_library(${sdf_target} ${sources})
target_compile_features(${sdf_target} PUBLIC cxx_std_17)
target_link_libraries(${sdf_target}
  PUBLIC
    ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER}
    ignition-utils${IGN_UTILS_VER}::ignition-utils${IGN_UTILS_VER}
  PRIVATE
    ${TinyXML2_LIBRARIES})

if (WIN32)
  target_compile_definitions(${sdf_target} PRIVATE URDFDOM_STATIC)
endif()

target_include_directories(${sdf_target}
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}/..>
)

message (STATUS "URDF_LIBRARY_DIRS=${URDF_LIBRARY_DIRS}")
message (STATUS "URDF_LIBRARIES=${URDF_LIBRARIES}")

if (NOT USE_INTERNAL_URDF)
  target_compile_options(${sdf_target} PRIVATE ${URDF_CFLAGS})
  if (${CMAKE_VERSION} VERSION_GREATER 3.13)
    target_link_options(${sdf_target} PRIVATE ${URDF_LDFLAGS})
  endif()
  target_link_libraries(${sdf_target} PRIVATE ${URDF_LIBRARIES})
endif()

sdf_install_library(${sdf_target})

if(NOT WIN32)
  add_subdirectory(cmd)
endif()

=== include/sdf/CMakeLists.txt ===
include (${sdf_cmake_dir}/SDFUtils.cmake)

set (headers
  Actor.hh
  AirPressure.hh
  Altimeter.hh
  Assert.hh
  Atmosphere.hh
  Box.hh
  Camera.hh
  Capsule.hh
  Collision.hh
  Console.hh
  Cylinder.hh
  Element.hh
  Ellipsoid.hh
  Error.hh
  Exception.hh
  Filesystem.hh
  ForceTorque.hh
  Frame.hh
  Geometry.hh
  Gui.hh
  Heightmap.hh
  Imu.hh
  InterfaceElements.hh
  InterfaceFrame.hh
  InterfaceJoint.hh
  InterfaceLink.hh
  InterfaceModel.hh
  InterfaceModelPoseGraph.hh
  Joint.hh
  JointAxis.hh
  Lidar.hh
  Light.hh
  Link.hh
  Magnetometer.hh
  Material.hh
  Mesh.hh
  Model.hh
  NavSat.hh
  Noise.hh
  Param.hh
  parser.hh
  ParserConfig.hh
  ParticleEmitter.hh
  Pbr.hh
  Physics.hh
  Plane.hh
  Root.hh
  Scene.hh
  SDFImpl.hh
  SemanticPose.hh
  Sensor.hh
  Sky.hh
  Sphere.hh
  Surface.hh
  Types.hh
  system_util.hh
  Visual.hh
  World.hh
)

set (sdf_headers "" CACHE INTERNAL "SDF headers" FORCE)
foreach (hdr ${headers})
  set(sdf_headers "${sdf_headers}#include <sdf/${hdr}>\n")
endforeach()
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/sdf.hh.in
                ${CMAKE_CURRENT_BINARY_DIR}/sdf.hh)

sdf_install_includes("" ${headers}
  ${CMAKE_CURRENT_BINARY_DIR}/sdf.hh)

=== test/integration/CMakeLists.txt ===
set(TEST_TYPE "INTEGRATION")

set(tests
  actor_dom.cc
  audio.cc
  category_bitmask.cc
  cfm_damping_implicit_spring_damper.cc
  collision_dom.cc
  converter.cc
  default_elements.cc
  deprecated_specs.cc
  disable_fixed_joint_reduction.cc
  element_tracing.cc
  fixed_joint_reduction.cc
  force_torque_sensor.cc
  frame.cc
  geometry_dom.cc
  include.cc
  includes.cc
  interface_api.cc
  joint_axis_frame.cc
  joint_axis_dom.cc
  joint_dom.cc
  light_dom.cc
  link_dom.cc
  link_light.cc
  locale_fix.cc
  locale_fix_cxx.cc
  material_pbr.cc
  material.cc
  model_dom.cc
  model_versions.cc
  nested_model.cc
  nested_multiple_elements_error.cc
  param_passing.cc
  parser_error_detection.cc
  parser_config.cc
  particle_emitter_dom.cc
  plugin_attribute.cc
  plugin_bool.cc
  plugin_include.cc
  provide_feedback.cc
  root_dom.cc
  scene_dom.cc
  sdf_basic.cc
  sdf_custom.cc
  surface_dom.cc
  unknown.cc
  urdf_gazebo_extensions.cc
  urdf_joint_parameters.cc
  visual_dom.cc
  whitespace.cc
  world_dom.cc
)

if (PYTHONINTERP_FOUND AND PY_PSUTIL)
  set(tests ${tests} element_memory_leak.cc)
endif()

find_program(XMLLINT_EXE xmllint)
if (EXISTS ${XMLLINT_EXE})
  set (tests ${tests} schema_test.cc)
else()
  BUILD_WARNING("xmllint not found. schema_test won't be run")
endif()

link_directories(${PROJECT_BINARY_DIR}/test)

sdf_build_tests(${tests})

if (EXISTS ${XMLLINT_EXE})
  # Need to run schema target (build .xsd files) before running schema_test
  add_dependencies(${TEST_TYPE}_schema_test schema)
endif()

# Test symbols having the right name on linux only
if (UNIX AND NOT APPLE)
  configure_file(all_symbols_have_version.bash.in ${CMAKE_CURRENT_BINARY_DIR}/all_symbols_have_version.bash @ONLY)
  add_test(NAME INTEGRATION_versioned_symbols
    COMMAND bash ${CMAKE_CURRENT_BINARY_DIR}/all_symbols_have_version.bash ${CMAKE_BINARY_DIR}/src/libsdformat${SDF_MAJOR_VERSION}.so)
endif()

=== debian/changelog ===
sdformat11 (11.3.0-1~buster) buster; urgency=medium

  * sdformat11 11.3.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Fri, 10 Sep 2021 17:33:45 -0700

sdformat11 (11.2.2-1~buster) buster; urgency=medium

  * sdformat11 11.2.2-1 release

 -- Addisu Z. Taddese <addisu@openrobotics.org>  Thu, 01 Jul 2021 17:13:02 -0500

sdformat11 (11.2.1-1~buster) buster; urgency=medium

  * sdformat11 11.2.1-1 release

 -- Louise Poubel <louise@openrobotics.org>  Tue, 29 Jun 2021 09:28:44 -0700

sdformat11 (11.2.0-1~buster) buster; urgency=medium

  * sdformat11 11.2.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Wed, 23 Jun 2021 12:47:04 -0700

sdformat11 (11.1.0-1~buster) buster; urgency=medium

  * sdformat11 11.1.0-1 release

 -- Jenn Nguyen <jenn@openrobotics.org>  Fri, 30 Apr 2021 15:13:22 -0700

sdformat11 (11.0.0-1~buster) buster; urgency=medium

  * sdformat11 11.0.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Wed, 31 Mar 2021 09:40:30 -0700

sdformat11 (11.0.0~pre3-1~buster) buster; urgency=medium

  * sdformat11 11.0.0~pre3-1 release

 -- Louise Poubel <louise@openrobotics.org>  Thu, 25 Mar 2021 12:08:13 -0700

sdformat11 (11.0.0~pre2-1~buster) buster; urgency=medium

  * sdformat11 11.0.0~pre2-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Mon, 08 Feb 2021 21:31:54 -0800

sdformat11 (11.0.0~pre1-1~buster) buster; urgency=medium

  * sdformat11 11.0.0~pre1-1 release

 -- Addizu Z. Taddese <addisu@openrobotics.org>  Tue, 19 Jan 2021 18:29:08 -0600

=== debian/control ===
Source: sdformat11
Standards-Version: 3.9.5
Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               python,
               libtinyxml2-dev,
               doxygen,
               texlive-base,
               texlive-fonts-recommended,
               texlive-latex-extra,
               ruby,
               libignition-tools-dev,
               libignition-math6-dev,
               libignition-utils1-dev
Vcs-Browser: https://github.com/ignition-release/sdformat11-release
Vcs-Git: https://github.com/ignition-release/sdformat11-release
Homepage: http://sdformat.org

Package: libsdformat11
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends:  sdformat11-sdf (>= ${source:Version}),
          ${shlibs:Depends},
          ${misc:Depends}
Multi-Arch: same
Breaks: libsdformat2,
        libsdformat3,
        libsdformat4,
        libsdformat5
Replaces: libsdformat2,
          libsdformat3,
          libsdformat4,
          libsdformat5
Description: Simulation Description Format (SDF) parser - Shared library
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.

Package: libsdformat11-dev
Architecture: any
Section: libdevel
Depends: libtinyxml2-dev,
         libignition-tools-dev,
         libignition-math6-dev,
         libignition-utils1-dev,
         libsdformat11 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libsdformat2-dev,
        libsdformat3-dev,
        libsdformat4-dev,
        libsdformat5-dev
Replaces: libsdformat2-dev,
        libsdformat3-dev,
        libsdformat4-dev,
        libsdformat5-dev
Multi-Arch: same
Description: Simulation Description Format (SDF) parser - Development files
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.

Package: sdformat11-sdf
Architecture: all
Section: libdevel
Depends: ${misc:Depends}
Multi-Arch: foreign
Conflicts: libsdformat1
Description: Simulation Description Format (SDF) parser - SDF files
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.
 .
 This package contains SDF (Simulation Description Format) XML files needed by
 the libsdformat.

Package: libsdformat11-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
     libsdformat11 (= ${binary:Version}),
     ${misc:Depends}
Multi-Arch: same
Description: Simulation Description Format (SDF) parser - Debugging symbols
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.

Package: sdformat11-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-jquery
Multi-Arch: foreign
Description: Simulation Description Format (SDF) parser - Documentation
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.
 .
 This package contains the program documentation

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

.PHONY: override_dh_auto_configure \
        override_dh_strip \
        override_dh_auto_test \
	override_dh_auto_build-indep


%:
	dh $@ --parallel

override_dh_auto_build-indep:
	dh_auto_build -- doc # Generate documentation.

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DCMAKE_BUILD_TYPE=RelWithDebInfo

# Tests are broken without a installed copy of sdformat.
# see: https://bitbucket.org/osrf/sdformat/issue/35
override_dh_auto_test:
	true

override_dh_strip:
	dh_strip -a --dbg-package=libsdformat11-dbg

=== debian/watch ===
version=3
http://gazebosim.org/assets/distributions/sdformat-(\d\.\d\.\d)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
